<?php
class floOS
{
	var $is_nutd = array();
	function floOS_version_compare($a, $b)
	{
	$pattern = array('/([a-z])/ei', '/\.+/', '/\.\Z|\A\./');
	$replacement = array( "'.'.intval('\\1', 36).'.'", '.', '');
	
	$array = preg_replace($pattern, $replacement, array($a, $b));
	
	return version_compare($array[0], $array[1], '>=');
	}
	function theme_version_search($dir)
	{
	global $template, $page;
	load_language('template.lang', PHPWG_ROOT_PATH.'template/floOS/tools/');
	$header_msgs = array();
	$dh = opendir ($dir);
	while (($file = readdir ($dh)) !== false ) {
		if ($file !== '.' && $file !== '..' && $file !== '.svn') { // enleve svn
			$path =$dir.'/'.$file;
			if (is_dir($path)) {
				$this->theme_version_search($path);
			}
			else
			{
			  $page = explode('.', $file);
			  $nb = count($page);
			  $nom_fichier = $page[0];
			  for ($i = 1; $i < $nb-1; $i++){
			   $nom_fichier .= '.'.$page[$i];
			  }
			  if(isset($page[1])){
			   $ext_fichier = $page[$nb-1];
			  }
			  else {
			   $ext_fichier = '';
			  }
			  if($nom_fichier == 'themeconf.inc' and $ext_fichier == 'php') {
				  include($path);
				  if (isset($themeconf['eid']))
				  {
					  if($this->is_not_up_to_date($themeconf['version'],$themeconf['eid']) )
					  {
						  
						  $msg=l10n('theme_update_needed_1').$themeconf['theme'].l10n('theme_update_needed_2').$themeconf['eid'].l10n('theme_update_needed_3').$themeconf['theme'].l10n('theme_update_needed_4');
						  $template->append('header_notes', $msg);
						  $this->is_nutd[$themeconf['theme']]=$themeconf['version'];
					  }
				  }
					  
			  }
			}
		}
	}
	closedir ($dh); // on ferme le repertoire courant
	}
	function is_not_up_to_date($v_local, $eid)
	{
	
	global $template, $user, $page;
	include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
	load_language('template.lang', PHPWG_ROOT_PATH.'template/floOS/tools/');
	
	// Retrieve PEM versions
	$version = PHPWG_VERSION;
	$versions_to_check = array();
	$url = PEM_URL . '/api/get_version_list.php?category_id=12&format=php';
	if (fetchRemote($url, $result) and $pem_versions = @unserialize($result))
	{
	  if (!preg_match('/^\d+\.\d+\.\d+/', $version))
	  {
		$version = $pem_versions[0]['name'];
	  }
	  $branch = substr($version, 0, strrpos($version, '.'));
	  foreach ($pem_versions as $pem_version)
	  {
		if (strpos($pem_version['name'], $branch) === 0)
		{
		  $versions_to_check[] = $pem_version['id'];
		}
	  }
	}
	
	// Retrieve PEM template infos
	$url = PEM_URL . '/api/get_revision_list.php?format=php&last_revision_only=true';
	$url .= '&version=' . implode(',', $versions_to_check);
	//$url .= '&lang=' . substr($user['language'], 0, 2);
	$url .= '&extension_include='.$eid;
	fetchRemote($url, $result);
	  $pem_res = @unserialize($result);
	  foreach($pem_res as $pem_floOS)
	  {
		  if (!is_array($pem_floOS))
		  {
			$template->assign(
				array(
				  'erreur' => 'erreur url : '.$url,
				)
			  );
		  }
		if (!$this->floOS_version_compare($v_local, $pem_floOS['revision_name']))
		{
			  return true;
		}
		else
		{
			return false;
		}
	  }
	}
	function display($names)
	{
		if (!is_array($names))
		{
			global $template;
			$template->assign(
				array(
					'erreur' => 'erreur get session var not array',
				)
			);
		}
		else
		{
			global $template, $user;
			load_language('template.lang', PHPWG_ROOT_PATH.'template/floOS/tools/');
			$r_names=$names;
			foreach($names as $name => $version)
			{
				if ($name=='floOS')
				{
					include(PHPWG_ROOT_PATH.'template/floOS/tools/version.conf.php');
					if ($this->floOS_version_compare($version, $floOS_conf['version']))
					{
						$template->append('header_notes', l10n('floOS_update_needed'));
					}
					else
					{
						$p=array_search($name,array_keys($r_names));
						array_splice ($r_names,$p,1);
					}
					
				}
				else
				{
					if ( is_dir(PHPWG_ROOT_PATH.'template/floOS/theme/'.$name) and is_file(PHPWG_ROOT_PATH.'template/floOS/theme/'.$name.'/themeconf.inc.php') )
					{
						include(PHPWG_ROOT_PATH.'template/floOS/theme/'.$name.'/themeconf.inc.php');
						if ($this->floOS_version_compare($version, $themeconf['version']))
						{
							$msg=l10n('theme_update_needed_1').$themeconf['theme'].l10n('theme_update_needed_2').$themeconf['eid'].l10n('theme_update_needed_3').$themeconf['theme'].l10n('theme_update_needed_4');
							$template->append('header_notes', $msg);
						}
						else
						{
							$p=array_search($name,array_keys($r_names));
							array_splice ($r_names,$p,1);
						}
					}
				}
			}
		}//else
		
	pwg_set_session_var('floOS_array_version',$r_names);
	}
}
?>